﻿using Newtonsoft.Json;
using Quartz;
using wms.dto.request;
using wms.dto.request.hj;
using wms.util;
using wms.util.Http;

namespace wms.api.Job
{
    /// <summary>
    /// 创建任务
    /// </summary>
    public class PostJob : IJob
    {
        public Task Execute(IJobExecutionContext context)
        {
            string jobCode = context.JobDetail.Key.Name;
            Action<string> action = new Action<string>(PostRequest);
            return Task.Run(() =>
            {
                PostRequest(jobCode);
            });
        }
        public void PostRequest(string jobCode)
        {

            var webBaseUrl = AppSettings.GetConfig("webapi");
            if (webBaseUrl == "http://10.30.44.3:8001")
            {
                HttpUtil.PostRequest(webBaseUrl + "/api/Hj/ExecuteJob", JsonConvert.SerializeObject(new DetailCodeRequest { Code = jobCode }));
            }
            else if (webBaseUrl == "http://10.30.44.4:8080")
            {
                HttpUtil.PostRequest(webBaseUrl + "/api/Pt/ExecuteJob", JsonConvert.SerializeObject(new DetailCodeStrRequest { Code = jobCode }));
            }
            else if (webBaseUrl == "http://10.30.44.4:8070")
            {
                HttpUtil.PostRequest(webBaseUrl + "/api/Cp/ExecuteJob", JsonConvert.SerializeObject(new DetailCodeStrRequest { Code = jobCode }));
            }

        }
    }
}
