﻿using System;
using System.Collections.Generic;
using System.Text;

namespace wms.dto.request.cp
{
    public class PalletAutoTaskRequest : BaseRequest
    {
        /// <summary>
        /// 箱号
        /// </summary>
        public string BoxCode { get; set; }
        /// <summary>
        /// 托盘码
        /// </summary>
        public string TrayCode { get; set; }
        /// <summary>
        /// 码垛工位
        /// </summary>
        public string Equip { get; set; }
        /// <summary>
        /// 工字轮型号
        /// </summary>
        public string HwType { get; set; }
        /// <summary>
        /// 托盘类型
        /// </summary>
        public string TrayType { get; set; }

        /// <summary>
        /// 托盘任务id
        /// </summary>
        public int TaskNum { get; set; }
        /// <summary>
        /// 底托 + 隔板 + 包装塑料袋 + 帘线塑料托盘 重量
        /// </summary>
        public decimal Wqty { get; set; }
        /// <summary>
        /// 包材重量（铁托之外的所有包材重量（包材重量可以由MES获取））
        /// </summary>
        public decimal PackWeight { get; set; }
        public List<PalletinfoDetail> list { get; set; }
    }
    public class PalletinfoDetail
    {
        /// <summary>
        /// 工字轮条码
        /// </summary>
        public string HWBarCode { get; set; }
        public string HuNr { get; set; }
        public string MaterialDesc { get; set; }
        public string MaterialCode { get; set; }
        public string GradeCode { get; set; }
        public string Sku { get; set; }
        public string MachineGroupcode { get; set; }
        public string OvcValue { get; set; }
        public decimal OvcFlag { get; set; }
        public decimal BadpointCount { get; set; }
        public int Layer { get; set; }
        public string InDocsNo { get; set; }
        public bool IsControlpanel { get; set; }
        public string Batch { get; set; }
        public bool IsBlack { get; set; }
        public string Winding { get; set; }
        public DateTime PalletizingDate { get; set; }
        /// <summary>
        /// 材料号
        /// </summary>
        public string? CLBarCode { get; set; }

        /// <summary>
        /// 码垛工位
        /// </summary>
        public string? EquNo { get; set; }
    }
}
