﻿using System;
using System.Collections.Generic;
using System.Text;

namespace wms.dto.request.cp
{
    public class ProductBoxDetailUploadRequest
    {
        public string TempHuNr { get; set; }
        public List<string> Lst_SpoolNr { get; set; } = new List<string>();
     }

    public class ProductBoxDetailUploadRequestNew
    {
        /// <summary>
        /// 箱号
        /// </summary>
        public string HuNr { get; set; }
        /// <summary>
        /// SKU
        /// </summary>
        public string SKU { get; set; }
        /// <summary>
        /// SKU描述
        /// </summary>
        public string SkuDesc { get; set; }
        /// <summary>
        /// 批次
        /// </summary>
        public string Batch { get; set; }
        /// <summary>
        /// 绕向
        /// </summary>
        public string Winding { get; set; }
        /// <summary>
        /// 装箱时间
        /// </summary>
        public string TimeStamp { get; set; }
        /// <summary>
        /// 装箱设备号
        /// </summary>
        public string MachineCode { get; set; }
        /// <summary>
        /// 仓库名称
        /// </summary>
        public string StoreName { get; set; } = "成品库";
        /// <summary>
        /// 仓库名称
        /// </summary>
        public string StoreCode { get; set; } = "cphouse";
        /// <summary>
        /// 库位
        /// </summary>
        public string LocatCode { get; set; } = "";
        /// <summary>
        /// OVC标记 0非检测盘，2检测合格
        /// </summary>
        public string OvcFlag { get; set; }
        /// <summary>
        /// 箱平均值
        /// </summary>
        public string OvcValue { get; set; }
        /// <summary>
        /// 层明细
        /// </summary>
        public List<LayerListItem> LayerList { get; set; } = new List<LayerListItem>();
    }

    public class LayerListItem
    {
        /// <summary>
        /// 层编码
        /// </summary>
        public string LayerCode { get; set; }
        /// <summary>
        /// 层名称
        /// </summary>
        public string layerName { get; set; }
        /// <summary>
        /// OVC标记
        /// </summary>
        public string OvcFlag { get; set; }
        /// <summary>
        /// 层平均值
        /// </summary>
        public string OvcValue { get; set; } = "";
        /// <summary>
        /// 层明细
        /// </summary>
        public List<SpoolListItem> SpoolList { get; set; } = new List<SpoolListItem>();
    }
    public class SpoolListItem
    {
        /// <summary>
        /// 工字轮号
        /// </summary>
        public string SpoolNr { get; set; }
        /// <summary>
        /// 材料号
        /// </summary>
        public string MatNo { get; set; }
    }
}
