﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;

namespace wms.dto.request.hj
{
    /// <summary>
    /// 库存改判请求实体
    /// </summary>
    public class StockChangeRequest:BaseRequest
    {
        /// <summary>
        /// 单号
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string BillCode { get; set; }
        /// <summary>
        /// 仓库编码
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string WareCode { get; set; }
        /// <summary>
        /// 改判信息列表
        /// </summary>
        public List<StockChangeRequestItem> ListInfo { get; set; } 
    }
    public class StockChangeRequestItem
    {
        /// <summary>
        /// RFID值
        /// </summary>
        public string RFID { get; set; }
        /// <summary>
        /// 材料号
        /// </summary>
        public string MatBarCode { get; set; }
        /// <summary>
        /// 物料编码
        /// </summary>
        public string MatCode { get; set; }
        /// <summary>
        /// 改判状态
        /// </summary>
        public string State { get; set; }
        /// <summary>
        /// 等级
        /// </summary>
        public string Grade { get; set; }
        /// <summary>
        /// 原因
        /// </summary>
        public string Reason { get; set; }
        /// <summary>
        /// 改判结果(反馈时使用)
        /// </summary>
        public string? ResState { get; set; }
        /// <summary>
        /// 原因 （反馈时使用）
        /// </summary>
        public string? ResDesc { get; set; }
        public string? HoldDuration { get; set; }
    }
}
