﻿using System;
using System.Collections.Generic;
using System.Text;

namespace wms.dto.request.hj
{
    /// <summary>
    /// 湿拉生产退料/余料/空轮申请请求实体
    /// </summary>
    public class WetLineBackInApplyRequest:BaseRequest
    {
        /// <summary>
        /// RFID值
        /// </summary>
        public string RFID { get; set; }
        /// <summary>
        /// 材料号 指令类型1，2时必传
        /// </summary>
        public string MatBarCode { get; set; }
        /// <summary>
        /// 物料编码 指令类型1，2时必传
        /// </summary>
        public string MatCode { get; set; }
        /// <summary>
        /// 生产日期 指令类型1，2时必传
        /// </summary>
        public DateTime ProductDate { get; set; }
        /// <summary>
        /// 工字轮类型 800/550，指令类型1，2时必传
        /// </summary>
        public string SpoolType { get; set; }
        /// <summary>
        /// 起始点位 指令类型1，2时必传
        /// </summary>
        public string StartLoc { get; set; } = "";
        /// <summary>
        /// 指令类型 1退料2余料3空轮
        /// </summary>
        public int BusType { get; set; }
        /// <summary>
        /// 退料原因 连断/夹丝/锈蚀；指令类型1时必传
        /// </summary>
        public string Reason { get; set; }
        /// <summary>
        /// 仓库编码
        /// </summary>
        public string WareCode { get; set; }
        /// <summary>
        /// 快投标记
        /// </summary>
        public string IsFast { get; set; }
        /// <summary>
        /// 等级
        /// </summary>
        public string Grade { get; set; }
        /// <summary>
        /// 是否锁定
        /// </summary>
        public string IsLock { get; set; }
        /// <summary>
        /// 数量
        /// </summary>
        public decimal Qty { get; set; }
        /// <summary>
        /// 是否返工
        /// </summary>
        public string? IsRework { get; set; }

        /// <summary>
        /// 请求编号
        /// </summary>
        public string ReqCode { get; set; }
    }
}
