﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;

namespace wms.dto.request.pt
{
    public class JKGetTunRes
    {
        /// <summary>
        /// 堆垛机编号
        /// </summary>
        public string palletizerNo { get; set; }
        /// <summary>
        /// 巷道编号
        /// </summary>
        public string rowNo { get; set; }

      
    }
    public class JKGetTunResNew
    {
        public List<JKGetTunRes> ListData { get; set; }
    }
    public class JKGetTunRequest
    {
        /// <summary>
        /// rfId
        /// </summary>
        [Required(ErrorMessage = "rfId不可为空")]
        public string rfId { get; set; }
    }


    public class JKPalletizerRequest
    {
        /// <summary>
        /// 请求的厂区编号
        /// </summary>
        public string wmsNo { get; set; }
        /// <summary>
        /// 堆垛机编号
        /// </summary>
        public string palletizerNo { get; set; }
        /// <summary>
        /// 巷道编号
        /// </summary>
        public string rowNo { get; set; }
        /// <summary>
        /// 任务编号
        /// </summary>
        public string taskId { get; set; }

        /// <summary>
        /// rfId
        /// </summary>
        public string rfId { get; set; }
        
    }


    public class JKPalletizerRes
    {
        /// <summary>
        /// 200-成功
        /// </summary>
        public int code { get; set; } = 200;
        /// <summary>
        /// 
        /// </summary>
        public string data { get; set; }
        /// <summary>
        /// 返回信息
        /// </summary>
        public string message { get; set; }
       
    }

    /// <summary>
    /// 到达放货站台请求
    /// </summary>
    public class JKArrRequest
    {
        /// <summary>
        /// rfId
        /// </summary>
        [Required(ErrorMessage = "rfId不可为空")]
        public string rfId { get; set; }
        /// <summary>
        /// 堆垛机编号
        /// </summary>
        public string palletizerNo { get; set; }
        /// <summary>
        /// 巷道编号
        /// </summary>
        public string rowNo { get; set; }
    }

    public class JKTransPTInfo
    {
        /// <summary>
        /// 单号
        /// </summary>
        public string BillCode { get; set; }
        /// <summary>
        /// 供应商编码
        /// </summary>
        public string SupCode { get; set; }
        /// <summary>
        /// 供应商名称
        /// </summary>
        public string SupName { get; set; }
        /// <summary>
        /// 单据类型
        /// </summary>
        [Required(ErrorMessage = "{0} 单据类型不可为空")]
        public string BillType { get; set; }
        /// <summary>
        /// 过账凭证号
        /// </summary>
        public string ReqId { get; set; }
        /// <summary>
        /// 仓库编码
        /// </summary>
        [Required(ErrorMessage = "{0} 仓库编码不可为空")]
        public string WareCode { get; set; }

        /// <summary>
        /// RFID
        /// </summary>
        public string RFID { get; set; }
        /// <summary>
        /// 盘条条码
        /// </summary>
        [Required(ErrorMessage = "{0} 盘条条码不可为空")]
        public string RodBar { get; set; }
        /// <summary>
        /// 物料编码
        /// </summary>
        [Required(ErrorMessage = "{0} 物料编码不可为空")]
        public string MatCode { get; set; }
        /// <summary>
        /// 炉号
        /// </summary>
        [Required(ErrorMessage = "{0} 炉号不可为空")]
        public string BoilerNo { get; set; }
        /// <summary>
        /// 材料号
        /// </summary>
        [Required(ErrorMessage = "{0} 材料号不可为空")]
        public string MatBarCode { get; set; }
        /// <summary>
        /// 包号
        /// </summary>
        [Required(ErrorMessage = "{0} 包号不可为空")]
        public string PackNo { get; set; }
        /// <summary>
        /// 生产批号
        /// </summary>
        [Required(ErrorMessage = "{0} 生产批号不可为空")]
        public string Batch { get; set; }
        /// <summary>
        /// 碳当量
        /// </summary>
        public decimal Carbon { get; set; }
        /// <summary>
        /// 生产日期
        /// </summary>
        [Required(ErrorMessage = "{0} 生产日期不可为空")]
        public DateTime ProductDate { get; set; }
        /// <summary>
        /// 牌号
        /// </summary>
        [Required(ErrorMessage = "{0} 牌号不可为空")]
        public string Brand { get; set; }
        /// <summary>
        /// 规格
        /// </summary>
        public string Describe { get; set; }
        /// <summary>
        /// 执行标准
        /// </summary>
        public string ExecStandard { get; set; }
        /// <summary>
        /// 许可证号
        /// </summary>
        public string Licence { get; set; }
        /// <summary>
        /// 包重
        /// </summary>
        public decimal Weight { get; set; }
        /// <summary>
        /// 时效期
        /// </summary>
        public decimal HoldDuration { get; set; }
    }
}
