﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;

namespace wms.dto.request.pt.dto
{
    public class PtWcsRequest
    {

    }
    /// <summary>
    /// 更新任务进程
    /// </summary>
    public class PtWcsTaskCallBackRequest
    {
        /// <summary>
        /// 任务号
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string TaskNum { get; set; }
        /// <summary>
        /// 任务状态（0.未下发；1.未执行;2~98.WCS任务进程状态,数据存入缓存）
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public int TaskStatus { get; set; }
        /// <summary>
        /// WCS操作人名称
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string WCSUpdateName { get; set; }
        /// <summary>
        /// 当前地址
        /// </summary>
        public string CurPosition { get; set; }
        /// <summary>
        /// 下个地址
        /// </summary>
        public string NextPosition { get; set; }
        /// <summary>
        /// 备用
        /// </summary>
        public string Memo1 { get; set; }
        /// <summary>
        /// 备用
        /// </summary>
        public string Memo2 { get; set; }
    }
    /// <summary>
    /// 分配货位
    /// </summary>
    public class PtApplyStockInLocRequest : BaseRequest
    {
        /// <summary>
        /// WMS任务号
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public int TaskNum { get; set; }
        /// <summary>
        /// 巷道号
        /// </summary>
        public int TunnelNum { get; set; }
        /// <summary>
        /// 取货地点设备编号
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string PickUpEquipmentNo { get; set; }
    }
    /// <summary>
    /// 堆垛机出库放货完成
    /// </summary>
    public class PtSrmPickOutCompletedRequest : BaseRequest
    {
        /// <summary>
        /// WMS任务号
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public int TaskNum { get; set; }
    }
    public class PtApplyLocRequest
    {
        public long WarehuoseId { get; set; }
        public int Size { get; set; }

        public int TunnelNum { get; set; }
        public long MaterialId { get; set; }
        public string MaterialCode { get; set; }
        public bool IsMove { get; set; } = false;
    }
    public class BarCodeRequest
    {
        public string Barcode { get; set; }
    }
    public class PtCreateStockOutTaskRequest
    {
        /// <summary>
        /// 容器条码
        /// </summary>
        public string ContGrpBarCode { get; set; }
        /// <summary>
        /// 仓库编码
        /// </summary>
        public string WarehouseCode { get; set; }
        public decimal Qty { get; set; }

        /// <summary>
        /// 设备编号
        /// </summary>
        public string EquCode { get; set; }
        /// <summary>
        /// 业务类型
        /// </summary>
        public string BusType { get; set; }
        public string Tunnel { get; set; }
        public string CellNo { get; set; }

        public string WorkBench { get; set; }

        /// <summary> 
        /// MatCode
        /// </summary> 
        public string MatCode { get; set; }

        /// <summary> 
        /// InvBarCode
        /// </summary> 
        public string InvBarCode { get; set; }
        /// <summary> 
        /// IsFast
        /// </summary> 
        public bool IsFast { get; set; }
        /// <summary> 
        /// Grade
        /// </summary> 
        public string Grade { get; set; }
        /// <summary> 
        /// IsSurplus
        /// </summary> 
        public bool IsSurplus { get; set; }
        /// <summary> 
        /// IsRework
        /// </summary> 
        public bool IsRework { get; set; }
        public string DocNo { get; set; }
    }
    public class WcsProductionOutRequest : BaseRequest
    {
    }
    public class PinkucarryTaskRequest : BaseRequest
    {
        public string Equip { get; set; }
    }
    public class ProductMaterInfoRequest : BaseRequest
    {
        public List<string> Code { get; set; }
        public string Equip { get; set; }
        /// <summary>
        /// 炉号
        /// </summary>
        public string BoilerNo { get; set; }
    }
}
