﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Text;

namespace wms.dto.request.pt.dto
{
    public class PtWebRequest
    {
    }
    /// <summary>
    /// 解绑
    /// </summary>
    public class PtUnboundRequest
    {
        /// <summary>
        /// 位置码
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string Equip { get; set; }
    }

    /// <summary>
    /// 采购入库
    /// </summary>
    public class PtPurchaseTaskReqest
    {
        /// <summary>
        /// 位置码
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string Equip { get; set; }

        /// <summary>
        /// 盘条容器码
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string? ConBarCode { get; set; } = "";
        /// <summary>
        /// 材料号
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string? MatBarCode { get; set; } = "";
    }
    /// <summary>
    /// 单据参数请求
    /// </summary>
    public class PtDocumentsRequest : PtBaseRequest
    {
        /// <summary>
        /// 单号
        /// </summary>
        public string? DocsNo { get; set; }
        /// <summary>
        /// 请求凭证号
        /// </summary>
        public string? ReqNo { get; set; }
        /// <summary>
        /// 单据类型
        /// </summary>
        public string? TypeCode { get; set; }
        /// <summary>
        /// 单据状态
        /// </summary>
        public string? StateCode { get; set; }
        public string? Rfid { get; set; }
        public string? location { get; set; }
    }
    public class PtManualTaskRequest
    {
        public List<string> Location { get; set; }
        [Required(ErrorMessage = "{0} 参数不可为空")]
        public string EndPoint { get; set; }
        public string? BusType { get; set; }
    }
    /// <summary>
    /// 库存请求参数
    /// </summary>
    public class PtStockRequest : PtBaseRequest
    {
        /// <summary>
        /// 容器id
        /// </summary>
        public string? RFID { get; set; }
        /// <summary>
        /// 工字轮型号
        /// </summary>
        public string? HWSpec { get; set; }
        /// <summary>
        /// 物料等级
        /// </summary>
        public string? Grade { get; set; }
        /// <summary>
        /// 巷道
        /// </summary>
        public string? Tunnel { get; set; }
        /// <summary>
        /// 货位号
        /// </summary>
        public string? Location { get; set; }
        /// <summary>
        /// 容器条码
        /// </summary>
        public string? ContGrpBarCode { get; set; }
        /// <summary>
        /// 材料号
        /// </summary>
        public string? InvBarCode { get; set; }
        /// <summary>
        /// 物料编码
        /// </summary>
        public string? MatCode { get; set; }
        /// <summary>
        /// 时效
        /// </summary>
        public decimal? HoldDuration { get; set; }
        /// <summary>
        /// 组盘状态
        /// </summary>
        public int GroupSate { get; set; }
    }
    /// <summary>
    /// 报错信息查询
    /// </summary>
    public class PtErrorInfoRequest
    {
        public string info { get; set; }
    }
    public class PtGroupInTaskRequest
    {
        public string Rfid { get; set; }
        public string Equip { get; set; }
    }
    public class PtAutoPurchData
    {
        public string Type { get; set; }
    }
    public class MoveTaskRequest
    {
        public int Tunnel { get; set; }
        public string Cell { get; set; }
        public string ToCell { get; set; }
    }
    public class UpdatePurchStateRequest
    {
        public List<long> Id { get; set;}
    }
    public class PtBaseRequest
    {
        [RegularExpression(@"^[0-9]*$", ErrorMessage = "{0}只能是数字")]
        public int PageIndex { get; set; } = 1;
        [RegularExpression(@"^[0-9]*$", ErrorMessage = "{0}只能是数字")]
        public int PageSize { get; set; } = 10;
        public List<DateTime>? AddTime { get; set; }
        public List<DateTime>? EditTime { get; set; }
    }

    public class BoilerNoRequest
    {
        public string BoilerNo { get; set; }
    }
}
