﻿using System;
using System.Collections.Generic;
using System.Text;

namespace wms.dto.response.cp
{
    public class BoxBuildStockTransResponse
    {
        public int TotalCount { get; set; }
        public List<BoxItems> Items { get; set; }
    }
    public class BoxItems
    {
        public string HuTotalWt { get; set; }
        public string HuTareWt { get; set; }
        public string HuNetWt { get; set; }
        public List<BoxItemlist> lst_Children { get; set; }
    }
    public class BoxItemlist
    {
        /// <summary>
        /// 机器组编码
        /// </summary>
        public string MachineGroupcode { get; set; }
        /// <summary>
        /// 焊点数量
        /// </summary>
        public decimal BadpointCount { get; set; }
        /// <summary>
        /// 是否做扭转检测 0 不做；1 做
        /// </summary>
        public decimal OvcFlag { get; set; }
        /// <summary>
        /// OVC检测值
        /// </summary>
        public string OvcValue { get; set; }
        /// <summary>
        /// 起鼓等级
        /// </summary>
        public string PlumpGrade { get; set; }
        /// <summary>
        /// 整箱净重
        /// </summary>
        public string HuNetWt { get; set; }
        /// <summary>
        /// 整箱重量
        /// </summary>
        public string HuTotalWt { get; set; }
        /// <summary>
        /// 皮重
        /// </summary>
        public string HuTareWt { get; set; }
        /// <summary>
        /// 工字轮上的物料编码
        /// </summary>
        public string MaterialCode { get; set; }
        /// <summary>
        /// 工字轮上的物料描述
        /// </summary>
        public string MaterialDesc { get; set; }
        /// <summary>
        /// 备注
        /// </summary>
        public string Remark { get; set; }
        /// <summary>
        /// 公司(帐套)代码
        /// </summary>
        public string CompanyCode { get; set; }
        /// <summary>
        /// 工字轮当前状态
        /// </summary>
        public string Status { get; set; }
        /// <summary>
        /// 绕向
        /// </summary>
        public string Winding { get; set; }
        /// <summary>
        /// 钢丝质量等级A/B/C/废品
        /// </summary>
        public string GradeCode { get; set; }
        /// <summary>
        /// /箱号
        /// </summary>
        public string HuNr { get; set; }
        /// <summary>
        /// 工字轮数量
        /// </summary>
        public short Count { get; set; }
        /// <summary>
        /// 批次
        /// </summary>
        public string Batch { get; set; }
        /// <summary>
        /// 装箱时间
        /// </summary>
        public string ProduceDate { get; set; }
        /// <summary>
        /// 产线
        /// </summary>
        public string ProdLine { get; set; }
        /// <summary>
        /// 产线代码
        /// </summary>
        public string ProdLineCode { get; set; }
        /// <summary>
        /// 主生产订单号
        /// </summary>
        public string OrderNo { get; set; }
        /// <summary>
        /// 工序订单号
        /// </summary>
        public string OrderProcessNo { get; set; }
        /// <summary>
        /// SKU
        /// </summary>
        public string Sku { get; set; }
        /// <summary>
        /// 班次
        /// </summary>
        public string ShiftNo { get; set; }
        /// <summary>
        /// 班别
        /// </summary>
        public string ShiftGroup { get; set; }
    }
}
