﻿using System;
using System.Collections.Generic;
using System.Text;

namespace wms.dto.response.cp
{
    public class CPGetCurStockListResponse : SRes
    {
        /// <summary>
        /// 总条数
        /// </summary>
        public int TotalCount { get; set; }
        /// <summary>
        /// 返回数据明细
        /// </summary>
        public List<CpResDataItem> ResData { get; set; }
    }
    public class CpResDataItem
    {
        /// <summary>
        /// 成品物料编码
        /// </summary>
        public string MatCode { get; set; }
        /// <summary>
        /// 成品物料描述
        /// </summary>
        public string MatName { get; set; }
        /// <summary>
        /// 有无焊点
        /// </summary>
        public string IsSolder { get; set; }
        /// <summary>
        /// SKU
        /// </summary>
        public string SKUCode { get; set; }
        /// <summary>
        /// SKU描述
        /// </summary>
        public string SKUDesc { get; set; }
        /// <summary>
        /// 控制扭转
        /// </summary>
        public string Tors { get; set; }
        /// <summary>
        /// 包装组ID
        /// </summary>
        public string PackGroupId { get; set; }
        /// <summary>
        /// 黑盘取样
        /// </summary>
        public string BlackSamp { get; set; }
        /// <summary>
        /// 黑盘检验
        /// </summary>
        public string BlackChk { get; set; }
        /// <summary>
        /// 客户编码
        /// </summary>
        public string CustCode { get; set; }
        /// <summary>
        /// 客户描述
        /// </summary>
        public string CustName { get; set; }
        /// <summary>
        /// 收货地址编码
        /// </summary>
        public string AddressCode { get; set; }
        /// <summary>
        /// 收货地址名称
        /// </summary>
        public string AddressName { get; set; }
        /// <summary>
        /// 生产批次数量（箱/批）
        /// </summary>
        public decimal Qty { get; set; }
        /// <summary>
        /// 每箱最大焊点盘数（个）
        /// </summary>
        public decimal BoxMaxSolder { get; set; }
        /// <summary>
        /// 工字轮最大焊点数（个）
        /// </summary>
        public decimal SpoolMaxSolder { get; set; }
        /// <summary>
        /// OVC比例
        /// </summary>
        public decimal OVC { get; set; }
        /// <summary>
        /// 起鼓等级
        /// </summary>
        public string DrummLevel { get; set; }
        /// <summary>
        /// 是否启用时效
        /// </summary>
        public bool IsHold { get; set; }
        /// <summary>
        /// 时效时长
        /// </summary>
        public decimal HoldDuration { get; set; }
        /// <summary>
        /// 箱号
        /// </summary>
        public string BoxNo { get; set; }
    }
}
