﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;

namespace wms.dto.response.hj
{
    /// <summary>
    /// 策略基本信息
    /// </summary>
    public class BaseStrategyDto
    {
        [Description("策略编号")]
        public string Code { get; set; }
        [Description("策略名称")]
        public string Name { get; set; }
        [Description("实现类")]
        public string ImplClass { get; set; }
        [Description("方向")]//0:入1:出
        public int Direct { get; set; }
        /// <summary>
        /// 存货编码
        /// </summary>
        [Description("存货编码")]
        public string MaterialCode { get; set; }
        /// <summary>
        /// 区域编号
        /// </summary>
        [Description("区域编号")]
        public string ZoneCode { get; set; }
        /// <summary>
        /// 区域名称
        /// </summary>
        [Description("区域名称")]
        public string ZoneName { get; set; }
        /// <summary>
        /// 仓库编号
        /// </summary>
        [Description("仓库编号")]
        public string WarehouseCode { get; set; }
        /// <summary>
        /// 仓库名称
        /// </summary>
        [Description("仓库名称")]
        public string WarehouseName { get; set; }
        /// <summary>
        /// 方向
        /// </summary>
        [Description("方向")]
        public string DirectName { get; set; }
        /// <summary>
        /// 关联id
        /// </summary>
        [Description("关联id")]
        public string RelationId { get; set; }
        /// <summary>
        /// 参数
        /// </summary>
        [Description("参数")]
        public string Parameters { get; set; } = "";
        /// <summary>
        /// 区域id
        /// </summary>
        [Description("区域id")]
        public long ZoneId { get; set; }
        /// <summary>
        /// 停留时间
        /// </summary>
        [Description("停留时间")]
        public int StayMinutes { get; set; }
        /// <summary>
        /// 同效力天数
        /// </summary>
        [Description("同效力天数")]
        public int SameEffectDays { get; set; }
        /// <summary>
        /// 优先级
        /// </summary>
        [Description("优先级")]
        public int Priority { get; set; }
        public List<BaseStrategyDto> StrategyDetailList { get; set; }
        //[Description("操作")]
        //[Sort(100)]
        //public string Operation { get; set; }
    }
}
