﻿using System;
using System.Collections.Generic;
using System.Text;

namespace wms.dto.response.pt
{
    /// <summary>
    /// 盘条实时库存查询响应
    /// </summary>
    public class PTGetCurStockListResponse : SRes
    {
        /// <summary>
        /// 总条数
        /// </summary>
        public int TotalCount { get; set; }
        /// <summary>
        /// 返回数据明细
        /// </summary>
        public List<PtResDataItem> list { get; set; }
    }
    public class PtResDataItem
    {
        /// <summary>
        /// RFID值
        /// </summary>
        public string RFID { get; set; }
        /// <summary>
        /// 盘条条码
        /// </summary>
        public string RodBar { get; set; }
        /// <summary>
        /// 炉号
        /// </summary>
        public string BoilerNo { get; set; }
        /// <summary>
        /// 材料号
        /// </summary>
        public string MatBarCode { get; set; }
        /// <summary>
        /// 包号
        /// </summary>
        public string PackNo { get; set; }
        /// <summary>
        /// 生产批号
        /// </summary>
        public string Batch { get; set; }
        /// <summary>
        /// 碳当量
        /// </summary>
        public decimal Carbon { get; set; }
        /// <summary>
        /// 生产日期
        /// </summary>
        public DateTime ProductDate { get; set; }
        /// <summary>
        /// 牌号
        /// </summary>
        public string Brand { get; set; }
        /// <summary>
        /// 规格
        /// </summary>
        public string Describe { get; set; }
        /// <summary>
        /// 执行标准
        /// </summary>
        public string ExecStandard { get; set; }
        /// <summary>
        /// 许可证号
        /// </summary>
        public string Licence { get; set; }
        /// <summary>
        /// 包重
        /// </summary>
        public decimal PackWeight { get; set; }
        /// <summary>
        /// 时效期
        /// </summary>
        public decimal HoldDuration { get; set; }
        /// <summary>
        /// 图号
        /// </summary>
        public string FigureNo { get; set; }
        /// <summary>
        /// 公司代码
        /// </summary>
        public string ComCode { get; set; }
        /// <summary>
        /// 公司名称
        /// </summary>
        public string ComName { get; set; }
        /// <summary>
        /// 计量单位
        /// </summary>
        public string CalcUnit { get; set; }
        /// <summary>
        /// 库存单位
        /// </summary>
        public string StockUnit { get; set; }
        /// <summary>
        /// 单重
        /// </summary>
        public decimal Weight { get; set; }
        /// <summary>
        /// 单重单位
        /// </summary>
        public string WeightUnit { get; set; }
        /// <summary>
        /// 是否启用时效
        /// </summary>
        public bool IsHold { get; set; }
        /// <summary>
        /// 时效时长
        /// </summary>
        public decimal HoldDurations { get; set; }
        /// <summary>
        /// 货位编码
        /// </summary>
        public string LocCode { get; set; }
        /// <summary>
        /// 行
        /// </summary>
        public string LocRow { get; set; }
        /// <summary>
        /// 列
        /// </summary>
        public string LocCell { get; set; }
        /// <summary>
        /// 层
        /// </summary>
        public string LocLayer { get; set; }
        /// <summary>
        /// 仓库编码
        /// </summary>
        public string WareCode { get; set; }
    }
    public class DeviceInfo
    {
        public string DeviceCode { get; set; }

        public string CurTunnel { get; set; }
    }
}
