﻿using System;
using System.Collections.Generic;
using System.Text;

namespace wms.dto.response.pt.dto
{
    public class PtWebResponse
    {
    }
    public class PtModel
    {
        public long Id { get; set; }
        public string AddWho { get; set; }
        public string EditWho { get; set; }
        public DateTime AddTime { get; set; }
        public DateTime EditTime { get; set; }
        public string Remark { get; set; }
        public string Default1 { get; set; }
        public string Default2 { get; set; }
        public string Default3 { get; set; }
        public string Default4 { get; set; }
        public string Default5 { get; set; }
    }
    /// <summary>
    /// 盘条单据反馈
    /// </summary>
    public class PtDocumentsResponse : PtModel
    {
        /// <summary>
        /// 行停用，false 启动，true 停用
        /// </summary>
        public bool IsStop { get; set; } = false;
        /// <summary>
        /// 仓库编码
        /// </summary>
        public string WarehouseCode { get; set; }
        /// <summary>
        /// 请求凭证号
        /// </summary>
        public string ReqNo { get; set; }
        /// <summary>
        /// 单号
        /// </summary>
        public string DocNo { get; set; }
        /// <summary>
        /// 单据类型
        /// </summary>
        public string TypeCode { get; set; }
        /// <summary>
        /// 单据状态
        /// </summary>
        public string StateCode { get; set; }
        /// <summary>
        /// 传递次数
        /// </summary>
        public int DownQty { get; set; }
        /// <summary>
        /// 下载失败原因
        /// </summary>
        public string DownErrReason { get; set; }
    }
    public class PtDocumentsdetailList : PtModel
    {
        /// <summary>
        /// 单据号
        /// </summary>
        public string InDocsNo { get; set; }
        /// <summary>
        /// 供应商编码
        /// </summary>
        public string SuppCode { get; set; }
        /// <summary>
        /// 供应商名称
        /// </summary>
        public string SuppName { get; set; }
        /// <summary>
        /// 物料编码
        /// </summary>
        public string MatCode { get; set; }
        /// <summary>
        /// 仓库编码
        /// </summary>
        public string WarehouseCode { get; set; }
        /// <summary>
        /// RFID条码
        /// </summary>
        public string RFIDBarCode { get; set; }
        /// <summary>
        /// 材料号
        /// </summary>
        public string InvBarCode { get; set; }
        /// <summary>
        /// 快投标记
        /// </summary>
        public bool IsFast { get; set; }
        /// <summary>
        /// 碳当量
        /// </summary>
        public decimal CaQty { get; set; }
        /// <summary>
        /// 物料名称
        /// </summary>
        public string MatName { get; set; }
        /// <summary>
        /// 货位
        /// </summary>
        public string Location { get; set; }
        /// <summary>
        /// 库存状态（锁定/放行）
        /// </summary>
        public string State { get; set; }
        /// <summary>
        /// 炉号
        /// </summary>
        public string BoilerNo { get; set; }
        /// <summary>
        /// 包号
        /// </summary>
        public string PackNo { get; set; }
        /// <summary>
        /// 盘条号
        /// </summary>
        public string RodBarCode { get; set; }
        /// <summary>
        /// 生产日期
        /// </summary>
        public DateTime ProductTime { get; set; }
        /// <summary>
        /// 数量
        /// </summary>
        public decimal Qty { get; set; }
    }
    public class BusinessDto2
    {
        public string Equip { get; set; }
        public string Con { get; set; }
        public DateTime Time { get; set; }
    }
}
