﻿using System;
using System.Collections.Generic;
using System.Linq.Expressions;
using System.Text;
using wms.dto.request;
using wms.dto.request.cp;
using wms.dto.request.cp.dto;
using wms.dto.request.hj;
using wms.dto.request.pt.dto;
using wms.dto.request.share;
using wms.dto.response;
using wms.dto.response.cp;
using wms.sqlsugar.model;
using wms.sqlsugar.model.cp;

namespace wms.service.IService
{
    public interface ICPService
    {
        public string GetSysConfigContentByCode(string code);
        public bool SyncMaterInfo(List<CPSyncMaterInfoResponseItem> ResData);
        public cpSysConfig GetSysConfigByCode(string code);
        public cpSysConfig GetSysConfigByExpression(Expression<Func<cpSysConfig, bool>> WhereExpression);
        public cpBaseMatinfo GetBaseMaterByExpression(Expression<Func<cpBaseMatinfo, bool>> WhereExpression);
        /// <summary>
        /// 获取反馈信息列表
        /// </summary>
        /// <param name="WhereExpression"></param>
        /// <returns></returns>
        public List<cpBillPushinfo> GetBillFeedbackList(Expression<Func<cpBillPushinfo, bool>> WhereExpression);
        List<cpBoxItems> GetBoxItemsList(Expression<Func<cpBoxItems, bool>> WhereExpression);
        public bool UpdateSysConfigModelColumns(UpdateModelColumns<cpSysConfig> updateModel);
        public bool UpdateBoxItemsModelColumns(UpdateModelColumns<cpBoxItems> updateModel);
        public SRes SalesDocTrans(SalesDocTransRequest reqDto);
        public SRes SalesBackDocTrans(SalesDocTransRequest reqDto);
        public SRes ErrorMaterialStockOut(ErrorMaterialStockOutRequest reqDto);
        public SRes StockChange(CpStockChangeRequest reqDto);
        public SRes MesReleaseFlag(MesReleaseFlagDto reqDto);
        public StockStateChangeResponse StockStateChange(StockStateChangeRequest reqDto);
        SRes PdaGroupStock(SouthPdaRequest request);
        SRes PdaTrayTaskOut(TrayGroupOutRequest request);
        SRes InsertWCSInTask(TrayGroupOutRequest request);
        SRes<string> GetCpTunnelPriorityList(GetTunnelPriorityListRequest reqEntity);
        SRes<int> CpCompleteTask(CompleteTaskRequest reqDto);
        SRes<CpApplyStockInLocResponse> CpApplyStockInLoc(CpApplyStockInLocRequest request);
        SRes CpWareCellInit(int row, int col, int deot, int rowcount, int tun);
        SRes ManualTask(CpManualTaskRequest request);
        SRes MesManualTask(CpMesManualTaskRequest request);
        SRes<int> CpSrmPickOutCompleted(CpSrmPickOutCompletedRequest request);
        SRes<WcsMoveTaskResponse> WcsMoveTask(WcsMoveTaskRequest request);
        SRes UpdateTaskState(UpdateTaskStateRequest request);
        SRes InsertBoxItems(List<cpBoxItems> request);
        CPGetCurStockListResponse GetCurStockList(CpGetCurStockListRequest reqDto);
        SRes SalesDocOutTask(SalesDocOutTaskRequest request);
        SRes SyncMaterInfoList(CpSyncMaterInfoListRequest request);
        SRes CpCancelTaskVerify(CancelTaskRequest request);
        SRes CpCarryTaskInfo(CancelTaskRequest request);
        bool UpdatePuchinfoModelColumns(UpdateModelColumns<cpBillPushinfo> updateModel);
        SRes ForceCancelTask(ErrorTaskRequest request);
        SRes DeleteStockInfo(DetailCodeStrRequest request);
        SRes UpdateStockState(DetailCodeStr1Requestdto request);
        SRes UpdateCellState(DetailCodeStr1Requestdto request);
        SRes DataSwapCell(DataSwapCellStrRequest request);
        SRes UpdateBoxFail(string boxcode);
        SRes DataBasePatch(DataBasePatchRequest request);
        SRes UpdatePurchState(UpdatePurchStateRequestdto request);
        SRes UpdateTaskAddrTo(UpdateTaskAddrToReq request);
        cpSysJob GetJobEntityByid(string id);
        cpSysJob GetJobEntityByCode(string Code);
        List<cpSysJobApiRelation> GetJobapilist(long id);
        SRes DataMoveCell(DataSwapCellStrRequest request);
        SRes ErpCancelStock(ErpCancelStockRequest request);
        SRes PdaStockInBack(SouthPdaRequest request);
        public List<cpBoxItems> GetBoxCodedetails(string Code);
        SRes PreLockedStock(PreLockedStockRequest request);
        public SRes MoveTaskInfo(MoveTaskRequest request);
        SRes TrayPortageTask(TrayGroupOutRequest request);
        SRes TrayPortageTaskCheck(TrayGroupOutRequest request);
        SRes PalletAutoInTask(PalletAutoTaskRequest request);
        SRes WcsUploadInfo(WcsUploadInfoRequest request);
        SRes<LabellingMachineResponse> LabellingMachine(LabellingMachineRequest request);
        public SRes<int> MonitorLeftStock(WebErrorRequest request);
        public SRes VerifyBoxNum(VerifyBoxNumRequest request);
        SRes DeleteoldBoxcodeinfo(string code);
        SRes UpdateErrorBoxinfo(string code, string remark);
        SRes ErrorManualTask(CpManualTaskRequest request);
        List<cpBoxItemsHistory> GetBoxItemsHistoryList(Expression<Func<cpBoxItemsHistory, bool>> WhereExpression);
        public SRes GenInventoryReport();
        SRes PalletManualMoveTask(PalletManualMoveTaskRequest request);
        SRes FlowDataMoveJob(SalesDocAutoPushRequest request);
    }
}
