﻿using System;
using System.Collections.Generic;
using System.Linq.Expressions;
using System.Text;
using wms.dto.request;
using wms.dto.request.hj;
using wms.dto.request.pt;
using wms.dto.request.pt.dto;
using wms.dto.request.share;
using wms.dto.response;
using wms.dto.response.pt;
using wms.dto.response.pt.dto;
using wms.sqlsugar.model;
using wms.sqlsugar.model.pt;

namespace wms.service.IService
{
    public interface IPTService
    {
        public string GetSysConfigContentByCode(string code);
        public bool SyncMaterInfo(List<PTSyncMaterInfoResponseItem> ResData);
        //public bool Add(ptBillDt data1);
        public ptSysConfig GetSysConfigByCode(string code);
        public ptSysConfig GetSysConfigByExpression(Expression<Func<ptSysConfig, bool>> WhereExpression);
        public List<ptSysConfig> GetSysConfigListByExpression(Expression<Func<ptSysConfig, bool>> WhereExpression);
        public ptBaseMater GetBaseMaterByExpression(Expression<Func<ptBaseMater, bool>> WhereExpression);
        /// <summary>
        /// 获取反馈信息列表
        /// </summary>
        /// <param name="WhereExpression"></param>
        /// <returns></returns>
        List<ptBillPushinfo> GetBillFeedbackList(string type);
        List<ptBillPushinfo> GetProductionFeedBack();
        public bool UpdateSysConfigModelColumns(UpdateModelColumns<ptSysConfig> updateModel);
        public SRes PurchaseBillTrans(PurchaseBillTransReqest request);
        public SRes PurchaseBillTransFeedBack(PurchaseBillTransFeedBackRequest reqDto);
        public SRes InsertBillInvinitCheck(PurchaseBillTransReqestCheck request);
        public SRes PurchaseRFIDCheck(PurchaseRFIDCheckReqest request);
        public ErpUnlockStockResponse ErpUnlockStock(ErpUnlockStockRequest reqDto);
        /// <summary>
        /// 生产领料出库
        /// </summary>
        /// <param name="reqDto"></param>
        /// <returns></returns>
        public SRes ProductionStockOut(ProductionStockOutRequest reqDto);
        public SRes ProductionFeedBack(ProductionFeedBackRequest reqDto);
        public SRes<StockChangeResItem> StockChange(PtStockChangeRequest reqDto);
        public SRes ProductionBack(ProductionBackRequest reqDto);
        public PTGetCurStockListResponse GetCurStockList(PtGetCurStockListRequest reqDto);
        SRes<int> Unbounding(PtUnboundRequest request);
        SRes<PtDocumentsdetailList> GetDocumentDetailListByDocsNo(PtDocumentsRequest request);
        SRes<PtDocumentsResponse> GetPageDocumentsList(PtDocumentsRequest request);
        string ManualTask(PtManualTaskRequest request);
        SRes PdaInsterInTask(PtGroupInTaskRequest request);
        SRes<string> GetPtTunnelPriorityList(GetTunnelPriorityListRequest reqEntity);
        SRes<PtApplyStockInLocResponse> PtApplyStockInLoc(PtApplyStockInLocRequest reqEntity);
        SRes<int> PtCompleteTask(CompleteTaskRequest reqDto);
        SRes<int> PtSrmPickOutCompleted(PtSrmPickOutCompletedRequest reqDto);
        SRes PtPurchaseTask(PtPurchaseTaskReqest request);
        public SRes GetSyncMaterInfo(PtSyncMaterInfoListRequest ResData);
        SRes WareCellInit(int row, int col, int deot, int rowcount, int tun);
        SRes WcsProductionOutRequest(WcsProductionOutRequest request);
        SRes WcsProductionOutRequest2(WcsProductionOutRequest request);
        bool UpdatePuchinfoModelColumns(UpdateModelColumns<ptBillPushinfo> updateModel);
        SRes PinkuInfoManagement(PtSrmPickOutCompletedRequest request);
        SRes PinKuCarryInTask(PinkucarryTaskRequest request);
        SRes PinKuCarryOutTask(PinkucarryTaskRequest request);
        SRes ProductMaterInfo(ProductMaterInfoRequest request);
        SRes PtCancelTaskVerify(CancelTaskRequest request);
        SRes PtCarryTaskInfo(CancelTaskRequest request);
        SRes MoveTaskInfo(MoveTaskRequest request);
        SRes ForceCancelTask(ErrorTaskRequest request);
        SRes DeleteStockInfo(DetailCodeStrRequest request);
        public SRes DeleteBarCodeInfo(DetailCodeStrRequest request);
        SRes UpdateStockState(DetailCodeStr1Requestdto request);
        SRes UpdateCellState(DetailCodeStr1Requestdto request);
        SRes DataSwapCell(DataSwapCellStrRequest request);
        SRes DataBasePatch(DetailCodeStrRequest request);
        ptSysJob GetJobEntityByid(string id);
        ptSysJob GetJobEntityByCode(string Code);
        List<ptSysJobApiRelation> GetJobapilist(long id);
        SRes UpdatePurchState(UpdatePurchStateRequest request);
        SRes DataMoveCell(DataSwapCellStrRequest request);
        SRes PdaProductRequisition(PtUnboundRequest request);
        public SRes PdaProductRequisition2(PtUnboundRequest request);
        public SRes HandErrTask(DetailRequest2Str request);
        public SRes UpdateDocState(UpdateDocStateReqest req);
        public SRes UpdateTaskCont(UpdateTaskContRequest req);
        public SRes UpdateLocationContGrpBarCode(UpdateLocationContGrpBarCode req);
        public SRes<int> MonitorLeftStock(WebErrorRequest request);
        SRes MoniterEmptCon(PtUnboundRequest request);
        public SRes AddStock(UpdateTaskContRequest req);
        public SRes<int> GetTaskNum(string rfid);
        public SRes<ptWCS_TaskOld> GetTask(int tasknum);
        public SRes<ptWCS_TaskInfo> GetCurTask(int tasknum);
        public SRes<bool> UpdateTask(int tasknum, string curpoint,string srm, string tunnel);
        public SRes FlowDataMoveJob(PtAutoPurchData request);
    }
}
