﻿using AutoMapper;
using System;
using System.Collections.Generic;
using System.Text;
using WCS.Entity;
using wms.dto.request;
using wms.dto.request.cp;
using wms.dto.request.fj;
using wms.dto.request.hj;
using wms.dto.request.hj.dto;
using wms.dto.request.pt;
using wms.dto.request.share;
using wms.dto.response;
using wms.dto.response.cp;
using wms.dto.response.fj;
using wms.dto.response.hj;
using wms.dto.response.pt.dto;
using wms.sqlsugar.model;
using wms.sqlsugar.model.cp;
using wms.sqlsugar.model.hj;
using wms.sqlsugar.model.pt;
using static wms.dto.request.hj.dto.ReportResponse;

namespace wms.service.mapper
{
    public class WmsPrifile : Profile
    {
        public WmsPrifile()
        {
            CreateMap<HJSyncMaterInfoResponseItem, hjBaseMater>()
                .ForMember(dest => dest.Code, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(dest => dest.Name, opt => opt.MapFrom(src => src.MatName))
                .ForMember(dest => dest.HeadTypeCode, opt => opt.MapFrom(src => src.HeadTypeCode))

                ;
            CreateMap<hjBillFeedbackPush, CopperLineStockInFeedBackItem>();
            CreateMap<hjBillFeedbackPush, WetLineBackInFeedBackRequestItem>();
            CreateMap<hjBillFeedbackPush, SpecialPickMaterFeedBackRequest>();
            CreateMap<hjBillFeedbackPush, SpecialPickMaterFeedBackRequestItem>();
            CreateMap<BillPushinfo, MoveStockFeedBackRequestItem>()
                .ForMember(dest => dest.MatBarCode, opt => opt.MapFrom(src => src.CLBarCode))
                .ForMember(dest => dest.RFID, opt => opt.MapFrom(src => src.RFIDBarCode))
                .ForMember(dest => dest.StartLoc, opt => opt.MapFrom(src => src.WareCellCode))
                .ForMember(dest => dest.EndLoc, opt => opt.MapFrom(src => src.Memo))
                .ForMember(dest => dest.WareCode, opt => opt.MapFrom(src => src.WarehouseCode))
                ;
            CreateMap<BillInvinit, BillInvnow>();
            CreateMap<BillInvnow, BillInvflow>();
            CreateMap<BillInvflow, BillInvnow>();
            CreateMap<WCS_TaskInfo, WCS_TaskOld>();
 
            CreateMap<CopperLineRequest, HjMaterialStockInRequest>();
            CreateMap<WetLineBackInApplyRequest, HjMaterialStockInRequest>();
            CreateMap<SysJob, dto.response.hj.SysJobDto>();
            CreateMap<ptSysJob, dto.response.hj.SysJobDto>();
            CreateMap<cpSysJob, dto.response.hj.SysJobDto>();

            

            CreateMap<BillPushinfo, ListInfo>()
                .ForMember(p => p.RFID, opt => opt.MapFrom(src => src.RFIDBarCode))
                .ForMember(p => p.MatCode, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(p => p.MatBarCode, opt => opt.MapFrom(src => src.CLBarCode))
                .ForMember(p => p.TolWeight, opt => opt.MapFrom(src => src.TolWQty))
                .ForMember(p => p.NetWeight, opt => opt.MapFrom(src => src.NetWQty))
                .ForMember(p => p.TareWeight, opt => opt.MapFrom(src => src.TareWQty))
                .ForMember(p => p.LocCode, opt => opt.MapFrom(src => src.WareCellCode))
                .ForMember(p => p.WareCode, opt => opt.MapFrom(src => src.WarehouseCode))
                .ForMember(p => p.IsMove, opt => opt.MapFrom(src => src.BoilerNo))
                .ForMember(p => p.WareName, opt => opt.MapFrom(src => src.WarehouseCode));

            CreateMap<BillPushinfo, WetLineBackInFeedBackRequestItem>()
                .ForMember(p => p.RFID, opt => opt.MapFrom(src => src.RFIDBarCode))
                .ForMember(p => p.MatBarCode, opt => opt.MapFrom(src => src.CLBarCode))
                .ForMember(p => p.MatCode, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(p => p.NetWeight, opt => opt.MapFrom(src => src.NetWQty))
                .ForMember(p => p.TareWeight, opt => opt.MapFrom(src => src.TareWQty))
                .ForMember(p => p.TolWeight, opt => opt.MapFrom(src => src.TolWQty))
                .ForMember(p => p.LocCode, opt => opt.MapFrom(src => src.WareCellCode))
                .ForMember(p => p.WareCode, opt => opt.MapFrom(src => src.WarehouseCode))
                .ForMember(p => p.WareName, opt => opt.MapFrom(src => "合金库"));

            //定时任务模块映射
            CreateMap<AddJobRequest, SysJob>();
            CreateMap<JobApiRelation, SysJobApiRelation>();
            CreateMap<SysJobApiRelation, JobApiRelation>();

            CreateMap<TunnelStatusEntity, TunnelStatusEntity>();

            CreateMap<HJSyncMaterInfoListRequestItem, HJSyncMaterInfoResponseItem>();
            CreateMap<FJSyncMaterInfoListRequestItem, FJSyncMaterInfoResponseItem>();
            CreateMap<FJSyncMaterInfoListRequestItem, BaseMatinfo>();
            CreateMap<HJSyncMaterInfoListRequestItem, BaseMatinfo>()
                 .ForMember(p => p.Code, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(p => p.Name, opt => opt.MapFrom(src => src.MatName))
                .ForMember(p => p.ShortDesc, opt => opt.MapFrom(src => src.Describe))
                .ForMember(p => p.Leafcode, opt => opt.MapFrom(src => src.LeafTypeCode))
                .ForMember(p => p.LeafName, opt => opt.MapFrom(src => src.LeafTypeCode))
                .ForMember(p => p.HeadCode, opt => opt.MapFrom(src => src.HeadTypeCode))
                .ForMember(p => p.Description, opt => opt.MapFrom(src => src.Describe))
                .ForMember(p => p.AddTime, opt => opt.MapFrom(src => DateTime.Now))
                .ForMember(p => p.IsHold, opt => opt.MapFrom(src => src.IsHold))
                .ForMember(p => p.HoldDuration, opt => opt.MapFrom(src => src.HoldDuration))
                .ForMember(p => p.WeightUnit, opt => opt.MapFrom(src => src.WeightUnit))
                ;


            CreateMap<UpdateMaterEntity, UpdateMaterEntity>();
            //任务
            CreateMap<hjBillTask, TaskRsponse>();
            CreateMap<TaskRsponse, hjBillTask>();
            CreateMap<hjBillTaskHistory, hjBillTask>();
            CreateMap<hjBillTask, hjBillTaskHistory>();
            //单据
            CreateMap<DocumentsResponse, hjBillDocument>();

            //库存
            CreateMap<RealTimeInventoryReportResponse, RealTimeInventoryReportResponse>();
            CreateMap<ExportModel, ExportModel>();

            CreateMap<MaterInfo, MaterInfo>();

            CreateMap<wms.sqlsugar.model.hj.BillInvflow, wms.sqlsugar.model.hj.hjBill_InvflowHty>();
            CreateMap<wms.sqlsugar.model.hj.BillPushinfo, wms.sqlsugar.model.hj.hjBillPushinfoHty>();

            #region 盘条库映射
            CreateMap<ptWCS_TaskInfo, PtTaskRsponse>();
            CreateMap<PtTaskRsponse, ptWCS_TaskInfo>();
            CreateMap<ptWCS_TaskInfo, ptWCS_TaskInfo>();
            CreateMap<ptWCS_TaskOld, ptWCS_TaskInfo>()
                .ForMember(p => p.ID, opt => opt.MapFrom(src => src.Id));
            CreateMap<ptWCS_TaskInfo, ptWCS_TaskOld>()
                .ForMember(p => p.Id, opt => opt.MapFrom(src => src.ID));

            CreateMap<ptBillInvinit, ptBillInvnow>();
            CreateMap<ptBillInvnow, ptBillInvinit>();
            CreateMap<ptBillInvnow, ptBillInvFlow>();
            CreateMap<ptBillInvFlow, ptBillInvnow>();
            CreateMap<ptBillInvinit, ptBillInvFlow>();

            //CreateMap<PTSyncMaterInfoListRequestItem, ptBaseMater>();
            CreateMap<PtSyncMaterInfoListRequest, ptBaseMater>()
                 .ForMember(p => p.Code, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(p => p.Name, opt => opt.MapFrom(src => src.MatName))
                .ForMember(p => p.ShortDesc, opt => opt.MapFrom(src => src.MatShortDesc))
                .ForMember(p => p.FullDesc, opt => opt.MapFrom(src => src.MatFullDesc))
                .ForMember(p => p.ExtDesc, opt => opt.MapFrom(src => src.MatExtDesc))
                .ForMember(p => p.Enname, opt => opt.MapFrom(src => src.MatEnName))
                .ForMember(p => p.Leafcode, opt => opt.MapFrom(src => src.LeafTypeCode))
                .ForMember(p => p.LeafName, opt => opt.MapFrom(src => src.LeafTypeName))
                .ForMember(p => p.MidCode, opt => opt.MapFrom(src => src.MidTypeCode))
                .ForMember(p => p.MidName, opt => opt.MapFrom(src => src.MidTypeName))
                .ForMember(p => p.HeadCode, opt => opt.MapFrom(src => src.HeadTypeCode))
                .ForMember(p => p.HeadName, opt => opt.MapFrom(src => src.HeadTypeName))
                .ForMember(p => p.Description, opt => opt.MapFrom(src => src.Describe))
                .ForMember(p => p.Texture, opt => opt.MapFrom(src => src.Texture))
                .ForMember(p => p.FigureNo, opt => opt.MapFrom(src => src.FigureNo))
                .ForMember(p => p.ComCode, opt => opt.MapFrom(src => src.ComCode))
                .ForMember(p => p.ComName, opt => opt.MapFrom(src => src.ComName))
                .ForMember(p => p.CalcUnit, opt => opt.MapFrom(src => src.CalcUnit))
                .ForMember(p => p.StockUnit, opt => opt.MapFrom(src => src.StockUnit))
                .ForMember(p => p.Weight, opt => opt.MapFrom(src => src.Weight))
                .ForMember(p => p.AddTime, opt => opt.MapFrom(src => DateTime.Now))
                .ForMember(p => p.EditTime, opt => opt.MapFrom(src => DateTime.Now))
                .ForMember(p => p.IsHold, opt => opt.MapFrom(src => src.IsHold))
                .ForMember(p => p.HoldDuration, opt => opt.MapFrom(src => src.HoldDuration))
                .ForMember(p => p.WeightUnit, opt => opt.MapFrom(src => src.WeightUnit))
                ;

            CreateMap<ptBillPushinfo, PurchaseBillTransFeedBackRequestItem>()
                .ForMember(p => p.RFID, opt => opt.MapFrom(src => src.RFIDBarCode))
                .ForMember(p => p.RodBar, opt => opt.MapFrom(src => src.RodBarCode))
                .ForMember(p => p.MatBarCode, opt => opt.MapFrom(src => src.CLBarCode))
                .ForMember(p => p.LocCode, opt => opt.MapFrom(src => src.WareCellCode))
                .ForMember(p => p.WareCode, opt => opt.MapFrom(src => src.WarehouseCode))
                .ForMember(p => p.WareName, opt => opt.MapFrom(src => "盘条库"));

            CreateMap<ptBillPushinfo, ProductionFeedBackRequestItem>()
                .ForMember(p => p.RFID, opt => opt.MapFrom(src => src.RFIDBarCode))
                .ForMember(p => p.BoilerNo, opt => opt.MapFrom(src => src.BoilerNo))
                .ForMember(p => p.MatBarCode, opt => opt.MapFrom(src => src.CLBarCode))
                .ForMember(p => p.PackNo, opt => opt.MapFrom(src => src.PackNo))
                .ForMember(p => p.Batch, opt => opt.MapFrom(src => src.BatchNo))
                .ForMember(p => p.ResState, opt => opt.MapFrom(src => src.ResStateCode))
                .ForMember(p => p.ResDesc, opt => opt.MapFrom(src => src.ResDesc))
                .ForMember(p => p.LocCode, opt => opt.MapFrom(src => src.WareCellCode))
                .ForMember(p => p.WareCode, opt => opt.MapFrom(src => src.WarehouseCode))
                .ForMember(p => p.WareName, opt => opt.MapFrom(src => "盘条库"));

            CreateMap<wms.sqlsugar.model.pt.ptBillInvFlow, wms.sqlsugar.model.pt.Bill_InvflowHty>();
            CreateMap<wms.sqlsugar.model.pt.ptBillPushinfo, wms.sqlsugar.model.pt.BillPushinfoHty>();

            #endregion

            CreateMap<FJSyncMaterInfoListRequestItem, FJSyncMaterInfoResponseItem>();
            CreateMap<FJSyncMaterInfoResponseItem, wms.sqlsugar.model.fj.BaseMatinfo>()
                .ForMember(p => p.Code, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(p => p.Name, opt => opt.MapFrom(src => src.MatName))
                .ForMember(p => p.ShortDesc, opt => opt.MapFrom(src => src.Describe))
                .ForMember(p => p.ProCode, opt => opt.MapFrom(src => src.ProCode))
                .ForMember(p => p.ProName, opt => opt.MapFrom(src => src.ProName))
                .ForMember(p => p.ProStre, opt => opt.MapFrom(src => src.ProStre))
                .ForMember(p => p.LinearMax, opt => opt.MapFrom(src => src.LinearMax))
                .ForMember(p => p.LinearMin, opt => opt.MapFrom(src => src.LinearMin))
                .ForMember(p => p.LinearTar, opt => opt.MapFrom(src => src.LinearTar))
                .ForMember(p => p.Plating, opt => opt.MapFrom(src => src.Plating))
                .ForMember(p => p.Mono, opt => opt.MapFrom(src => src.Mono))
                .ForMember(p => p.PlatingWeight, opt => opt.MapFrom(src => src.PlatingWeight))
                .ForMember(p => p.Description, opt => opt.MapFrom(src => src.Describe))
                .ForMember(p => p.AddTime, opt => opt.MapFrom(src => DateTime.Now))
                .ForMember(p => p.IsHold, opt => opt.MapFrom(src => src.IsHold))
                .ForMember(p => p.HoldDuration, opt => opt.MapFrom(src => src.HoldDuration))

                ; ;
            CreateMap<FJSyncMaterInfoListRequestItem, FJSyncMaterInfoResponseItem>();
            CreateMap<FJSyncMaterInfoListRequestItem, BaseMatinfo>();

            CreateMap<wms.sqlsugar.model.fj.BillPushinfo, WetProductStockInFeedBackRequestItem>();

            #region 成品库映射
            CreateMap<cpWCS_TaskInfo, cpWCS_TaskInfo>();
            CreateMap<cpWCS_TaskOld, cpWCS_TaskInfo>();
            CreateMap<cpWCS_TaskInfo, cpWCS_TaskOld>();

            CreateMap<cpBillInvinit, cpBillInvnow>();
            CreateMap<cpBillInvnow, cpBillInvinit>();
            CreateMap<cpBillInvnow, cpBillInvflow>();
            CreateMap<cpBillInvflow, cpBillInvnow>();
            CreateMap<cpBoxItemsHistory, cpBoxItems>();
            CreateMap<cpBoxItems, cpBoxItemsHistory>();
            CreateMap<BoxItemlist, cpBoxItems>();
            CreateMap<CpSyncMaterInfoListRequest, cpBaseMatinfo>()
                 .ForMember(p => p.Code, opt => opt.MapFrom(src => src.MatCode))
                .ForMember(p => p.Name, opt => opt.MapFrom(src => src.MatName))
                .ForMember(p => p.IsSolder, opt => opt.MapFrom(src => src.IsSolder))
                .ForMember(p => p.SkuCode, opt => opt.MapFrom(src => src.SKUCode))
                .ForMember(p => p.SkuDesc, opt => opt.MapFrom(src => src.SKUDesc))
                .ForMember(p => p.Tors, opt => opt.MapFrom(src => src.Tors))
                .ForMember(p => p.PackGrpId, opt => opt.MapFrom(src => src.PackGroupId))
                .ForMember(p => p.BlackSamp, opt => opt.MapFrom(src => src.BlackSamp))
                .ForMember(p => p.BlackChk, opt => opt.MapFrom(src => src.BlackChk))
                .ForMember(p => p.CustCode, opt => opt.MapFrom(src => src.CustCode))
                .ForMember(p => p.CustName, opt => opt.MapFrom(src => src.CustName))
                .ForMember(p => p.AddressCode, opt => opt.MapFrom(src => src.AddressCode))
                .ForMember(p => p.AddressName, opt => opt.MapFrom(src => src.AddressName))
                .ForMember(p => p.Qty, opt => opt.MapFrom(src => src.Qty))
                .ForMember(p => p.BoxMaxSolder, opt => opt.MapFrom(src => src.BoxMaxSolder))
                .ForMember(p => p.SpoolMaxSolder, opt => opt.MapFrom(src => src.SpoolMaxSolder))
                .ForMember(p => p.Ovc, opt => opt.MapFrom(src => src.OVC))
                .ForMember(p => p.DrummLevel, opt => opt.MapFrom(src => src.DrummLevel))
                .ForMember(p => p.IsHold, opt => opt.MapFrom(src => src.IsHold))
                .ForMember(p => p.HoldDuration, opt => opt.MapFrom(src => src.HoldDuration))
                ;
            CreateMap<cpBillPushinfo, dto.request.cp.StockChangeFeedBackRequestItem>()
                .ForMember(p => p.BoxNo, opt => opt.MapFrom(src => src.RFIDBarCode))
                .ForMember(p => p.SpoolCode, opt => opt.MapFrom(src => src.HWBarCode))
                .ForMember(p => p.MatBarCode, opt => opt.MapFrom(src => src.CLBarCode))
                .ForMember(p => p.ResState, opt => opt.MapFrom(src => src.ResStateCode))
                .ForMember(p => p.ResDesc, opt => opt.MapFrom(src => src.ResDesc));

            CreateMap<cpBillPushinfo, MoveStockLocationFeedBackRequest>()
                .ForMember(p => p.BoxNo, opt => opt.MapFrom(src => src.HWBarCode))
                .ForMember(p => p.WareCode, opt => opt.MapFrom(src => src.WarehouseCode))
                .ForMember(p => p.StartLoc, opt => opt.MapFrom(src => src.Memo))
                .ForMember(p => p.EndLoc, opt => opt.MapFrom(src => src.WareCellCode));
            CreateMap<PalletinfoDetail, cpBoxItems>()
                .ForMember(p => p.GradeCode, opt => opt.MapFrom(src => src.GradeCode))
                .ForMember(p => p.Sku, opt => opt.MapFrom(src => src.Sku))
                .ForMember(p => p.HuNr, opt => opt.MapFrom(src => src.HuNr))
                .ForMember(p => p.HWBarCode, opt => opt.MapFrom(src => src.HWBarCode))
                .ForMember(p => p.OvcValue, opt => opt.MapFrom(src => src.OvcValue))
                .ForMember(p => p.OvcFlag, opt => opt.MapFrom(src => src.OvcFlag))
                .ForMember(p => p.BadpointCount, opt => opt.MapFrom(src => src.BadpointCount))
                .ForMember(p => p.MachineGroupcode, opt => opt.MapFrom(src => src.MachineGroupcode))
                .ForMember(p => p.InDocsNo, opt => opt.MapFrom(src => src.InDocsNo))
                .ForMember(p => p.Batch, opt => opt.MapFrom(src => src.Batch))
                .ForMember(p => p.Layer, opt => opt.MapFrom(src => src.Layer))
                .ForMember(p => p.Winding, opt => opt.MapFrom(src => src.Winding))
                .ForMember(p => p.IsBlack, opt => opt.MapFrom(src => src.IsBlack))
                .ForMember(p => p.IsControlpanel, opt => opt.MapFrom(src => src.IsControlpanel))
                .ForMember(p => p.PalletizingDate, opt => opt.MapFrom(src => src.PalletizingDate));

            CreateMap<wms.sqlsugar.model.cp.cpBillInvflow, wms.sqlsugar.model.cp.cpBill_InvflowHty>();
            CreateMap<wms.sqlsugar.model.cp.cpBillPushinfo, wms.sqlsugar.model.cp.cpBillPushinfoHty>();
            CreateMap<wms.sqlsugar.model.cp.cpBoxItems, wms.sqlsugar.model.cp.cpBoxItemsHty>();
            #endregion
        }
    }
}
