﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Text;

namespace wms.sqlsugar.model.cp
{
    [Tenant("cp")]
    [SugarTable("Bill_InventoryReport")]
    public class cpBillInventoryReport : BaseModel
    {
      
        /// <summary> 
        /// 年月
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false)]
        public string DateMonth { get; set; }

        /// <summary> 
        /// 类别
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false)]
        public string NameType { get; set; }

        /// <summary> 
        /// 期初
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, DecimalDigits = 3, IsNullable = false)]
        public decimal BeginQty { get; set; }
        /// <summary> 
        /// 期末
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, DecimalDigits = 3, IsNullable = false)]
        public decimal EndQty { get; set; }


        /// <summary> 
        /// 入库量
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, DecimalDigits = 3, IsNullable = false)]
        public decimal StockInQty { get; set; }

        /// <summary> 
        /// 销售出库
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, DecimalDigits = 3, IsNullable = false)]
        public decimal SalesStockOutQty { get; set; }

        /// <summary> 
        /// 退生产（生产出库）
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, DecimalDigits = 3, IsNullable = false)]
        public decimal ProductStockOutQty { get; set; }

        /// <summary> 
        /// 开始时间（上个月最后一天的8:30）
        /// </summary> 
        [SugarColumn(ColumnDataType = "datetime", IsNullable = false)]
        public DateTime StartTime { get; set; }

        /// <summary> 
        /// 结束时间（当月最后一天的8:30）
        /// </summary> 
        [SugarColumn(ColumnDataType = "datetime", IsNullable = false)]
        public DateTime EndTime { get; set; }

        /// <summary> 
        /// 手动出库
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, DecimalDigits = 3, IsNullable = false)]
        public decimal ManualStockOutQty { get; set; }
    }
}
