﻿using System; 
using System.Collections.Generic;
using SqlSugar;

namespace wms.sqlsugar.model.cp
{
    [Tenant("cp")]
    [SugarTable("Bill_InvInit")]
    public partial class cpBillInvinit : BaseModel
    { 

        /// <summary> 
        /// 仓库id
        /// </summary> 
        [SugarColumn(ColumnDataType ="bigint" ,  IsNullable = false )]
        public long WarehouseId { get; set; }

        /// <summary> 
        /// 组盘id
        /// </summary> 
        [SugarColumn(ColumnDataType ="bigint" ,  IsNullable = false )]
        public long ContGrpId { get; set; }

        /// <summary> 
        /// 容器条码
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string ContGrpBarCode { get; set; }

        /// <summary> 
        /// 箱号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string BoxBarCode { get; set; }

        /// <summary> 
        /// Bom工单号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string BomDocsNo { get; set; }

        /// <summary> 
        /// Bom物料id
        /// </summary> 
        [SugarColumn(ColumnDataType ="bigint" ,  IsNullable = false )]
        public long BomMatId { get; set; }

        /// <summary> 
        /// Bom物料编码
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string BomMatCode { get; set; }

        /// <summary> 
        /// Bom物料名称
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 100  , IsNullable = true )]
        public string BomMatName { get; set; }

        /// <summary> 
        /// BomSetId
        /// </summary> 
        [SugarColumn(ColumnDataType ="bigint" ,  IsNullable = false )]
        public long BomSetId { get; set; }

        /// <summary> 
        /// 库存状态（锁定/正常）
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string ExecStateCode { get; set; }

        /// <summary> 
        /// 生产订单号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string ExecDocsNo { get; set; }

        /// <summary> 
        /// 生产订单行号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string ExecDocsRowNo { get; set; }

        /// <summary> 
        /// 生产订单类型编码
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string ExecDocsTypeCode { get; set; }

        /// <summary> 
        /// 出入库
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int InvInOut { get; set; }

        /// <summary> 
        /// 执行用户
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string ExecWho { get; set; }

        /// <summary> 
        /// 执行时间
        /// </summary> 
        [SugarColumn(ColumnDataType ="datetime" ,  IsNullable = false )]
        public DateTime ExecTime { get; set; }

        /// <summary> 
        /// 行
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int PutRow { get; set; }

        /// <summary> 
        /// 列
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int PutCol { get; set; }

        /// <summary> 
        /// 层
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int PutLayer { get; set; }

        /// <summary> 
        /// 材料号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string InvBarCode { get; set; }

        /// <summary> 
        /// 组盘状态
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string InvStateCode { get; set; }

        /// <summary> 
        /// 入库单据号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string InDocsNo { get; set; }

        /// <summary> 
        /// 入库单行号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string InDocsRowNo { get; set; }

        /// <summary> 
        /// 供应商编码
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string SuppCode { get; set; }

        /// <summary> 
        /// 供应商名称
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string SuppName { get; set; }

        /// <summary> 
        /// 客户编码
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string CustCode { get; set; }

        /// <summary> 
        /// 客户名称
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string CustName { get; set; }

        /// <summary> 
        /// MatId
        /// </summary> 
        [SugarColumn(ColumnDataType ="bigint" ,  IsNullable = false )]
        public long MatId { get; set; }

        /// <summary> 
        /// MatCode
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string MatCode { get; set; }

        /// <summary> 
        /// MatName
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 100  , IsNullable = true )]
        public string MatName { get; set; }

        /// <summary> 
        /// 总重量
        /// </summary> 
        [SugarColumn(ColumnDataType ="decimal" , Length = 18, DecimalDigits = 6, IsNullable = false )]
        public decimal TolWQty { get; set; }

        /// <summary> 
        /// 净重
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, DecimalDigits = 6, IsNullable = false)]
        public decimal NetWQty { get; set; }

        /// <summary> 
        /// 皮重
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, DecimalDigits = 6, IsNullable = false)]
        public decimal TareWQty { get; set; }

        /// <summary> 
        /// 长度
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, DecimalDigits = 6, IsNullable = false)]
        public decimal LengthQty { get; set; }

        /// <summary> 
        /// 碳当量
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, DecimalDigits = 6, IsNullable = false)]
        public decimal CaQty { get; set; }

        /// <summary> 
        /// 焊点数量
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, DecimalDigits = 6, IsNullable = false)]
        public decimal SolderQty { get; set; }

        /// <summary> 
        /// 工字轮数量
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int ContUsageQty { get; set; }

        /// <summary> 
        /// 批号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string BatchNo { get; set; }

        /// <summary> 
        /// ProductTime
        /// </summary> 
        [SugarColumn(ColumnDataType ="datetime" ,  IsNullable = false )]
        public DateTime ProductTime { get; set; }

        /// <summary> 
        /// OneInTime
        /// </summary> 
        [SugarColumn(ColumnDataType ="datetime" ,  IsNullable = false )]
        public DateTime OneInTime { get; set; }

        /// <summary> 
        /// RodBarCode
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string RodBarCode { get; set; }

        /// <summary> 
        /// 工字轮条码
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string HWBarCode { get; set; }

        /// <summary> 
        /// RFID条码
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string RFIDBarCode { get; set; }

        /// <summary> 
        /// CLBarCode
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string CLBarCode { get; set; }

        /// <summary> 
        /// HWTypeCode
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string HWTypeCode { get; set; }

        /// <summary> 
        /// 炉号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string BoilerNo { get; set; }

        /// <summary> 
        /// 包号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string PackNo { get; set; }

        /// <summary> 
        /// 牌号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string BrandNo { get; set; }

        /// <summary> 
        /// 绕向
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string ExecStd { get; set; }

        /// <summary> 
        /// 起鼓等级
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string LicenceCode { get; set; }

        /// <summary> 
        /// 余料
        /// </summary> 
        [SugarColumn(ColumnDataType ="bit" , IsNullable = false )]
        public bool IsSurplus { get; set; }

        /// <summary> 
        /// 返工标记
        /// </summary> 
        [SugarColumn(ColumnDataType ="bit" , IsNullable = false )]
        public bool IsRework { get; set; }

        /// <summary> 
        /// 是否黑盘
        /// </summary> 
        [SugarColumn(ColumnDataType ="bit" , IsNullable = false )]
        public bool IsBlack { get; set; }

        /// <summary> 
        /// 是否芯股
        /// </summary> 
        [SugarColumn(ColumnDataType ="bit" , IsNullable = false )]
        public bool IsCore { get; set; }

        /// <summary> 
        /// 快投标记
        /// </summary> 
        [SugarColumn(ColumnDataType ="bit" , IsNullable = false )]
        public bool IsFast { get; set; }

        /// <summary> 
        /// 是否异常
        /// </summary> 
        [SugarColumn(ColumnDataType ="bit" , IsNullable = false )]
        public bool IsFail { get; set; }

        /// <summary> 
        /// 异常原因
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 200  , IsNullable = true )]
        public string FailReason { get; set; }

        /// <summary> 
        /// 单/双丝
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string SilkTypeCode { get; set; }

        /// <summary> 
        /// Grade
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string Grade { get; set; }

        /// <summary> 
        /// 是否退料
        /// </summary> 
        [SugarColumn(ColumnDataType ="bit" , IsNullable = false )]
        public bool IsBack { get; set; }

        /// <summary> 
        /// 退料原因
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 200  , IsNullable = true )]
        public string BackReason { get; set; }

        /// <summary> 
        /// 是否 扭转检测
        /// </summary> 
        [SugarColumn(ColumnDataType ="bit" , IsNullable = false )]
        public bool IsTorsChk { get; set; }

        /// <summary> 
        /// 扭转次数
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int TorsChkQty { get; set; }

        /// <summary> 
        /// 扭转检测时间
        /// </summary> 
        [SugarColumn(ColumnDataType ="datetime" ,  IsNullable = false )]
        public DateTime TorsChkTime { get; set; }

        /// <summary> 
        /// 扭转检测结果值
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, DecimalDigits = 6, IsNullable = true)]
        public decimal? TorsChkValue { get; set; }

        /// <summary> 
        /// 扭转检测设备号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string TorsChkMachCode { get; set; }

        /// <summary> 
        /// 工序订单号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string ProcessDocsCode { get; set; }

        /// <summary> 
        /// 机器组编码
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string ProductMachCode { get; set; }

        /// <summary> 
        /// ProductLineNo
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string ProductLineNo { get; set; }

        /// <summary> 
        /// 货物大小
        /// </summary> 
        [SugarColumn(IsNullable = false)]
        public int Size { get; set; }
        /// <summary>
        /// 1 放行/ 2 冻结 ERP使用
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string State { get; set; }
        /// <summary>
        /// 销售发货单预冻结
        /// </summary>
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string SalesDoc { get; set; }
    }
}

