﻿using System; 
using System.Collections.Generic;
using SqlSugar;

namespace wms.sqlsugar.model.fj
{
    [Tenant("fj")]
    [SugarTable("Base_WareCell")]
    public partial class BaseWarecell:BaseModel
    { 

        /// <summary> 
        /// WarehouseId
        /// </summary> 
        [SugarColumn(ColumnDataType ="bigint" ,  IsNullable = false )]
        public long WarehouseId { get; set; }

        /// <summary> 
        /// 仓库编码
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false)]
        public string WarehouseCode { get; set; }

        /// <summary> 
        /// WareAreaId
        /// </summary> 
        [SugarColumn(ColumnDataType ="bigint" ,  IsNullable = false )]
        public long WareAreaId { get; set; }

        /// <summary> 
        /// IsStop
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int IsStop { get; set; }

        /// <summary> 
        /// Code
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = false )]
        public string Code { get; set; }

        /// <summary> 
        /// Name
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 100  , IsNullable = false )]
        public string Name { get; set; }

        /// <summary> 
        /// StateNum
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int StateNum { get; set; }

        /// <summary> 
        /// TypeNum
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int TypeNum { get; set; }

        /// <summary> 
        /// 货位大小
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" , IsNullable = false )]
        public long Size { get; set; }

        /// <summary> 
        /// Row
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int Row { get; set; }

        /// <summary> 
        /// Col
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int Col { get; set; }

        /// <summary> 
        /// Layer
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int Layer { get; set; }

        /// <summary> 
        /// Depth
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int Depth { get; set; }

        /// <summary> 
        /// Tunnel
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int Tunnel { get; set; }

        /// <summary> 
        /// SCRel
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = false )]
        public string SCRel { get; set; }

        /// <summary> 
        /// ContGrpId
        /// </summary> 
        [SugarColumn(ColumnDataType ="bigint" ,  IsNullable = true )]
        public long? ContGrpId { get; set; }

        /// <summary> 
        /// ContGrpBarCode
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = true )]
        public string ContGrpBarCode { get; set; }

        /// <summary> 
        /// Shelf
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string Shelf { get; set; }

        /// <summary> 
        /// Memo
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 500  , IsNullable = false )]
        public string Memo { get; set; }

        /// <summary> 
        /// AddWho
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = false )]
        public string AddWho { get; set; }

        /// <summary> 
        /// AddTime
        /// </summary> 
        [SugarColumn(ColumnDataType ="datetime" ,  IsNullable = false )]
        public DateTime AddTime { get; set; }

        /// <summary> 
        /// EditWho
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = false )]
        public string EditWho { get; set; }

        /// <summary> 
        /// EditTime
        /// </summary> 
        [SugarColumn(ColumnDataType ="datetime" ,  IsNullable = false )]
        public DateTime EditTime { get; set; }


    }
}

