﻿using System; 
using System.Collections.Generic;
using SqlSugar;

namespace wms.sqlsugar.model.fj
{
    [Tenant("fj")]
    [SugarTable("Bill_MachInfo")]
    public partial class BillMachinfo:BaseModel
    { 
        /// <summary> 
        /// 仓库id
        /// </summary> 
        [SugarColumn(ColumnDataType ="bigint" ,  IsNullable = false )]
        public long WarehouseId { get; set; }

        /// <summary> 
        /// 仓库编码（1N,1S,2N,2S,3N,3S）
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50)]
        public string WarehouseCode { get; set; }

        /// <summary> 
        /// 分拣库序号
        /// </summary> 
        [SugarColumn(ColumnDataType = "int")]
        public int WarehouseSort { get; set; }

        /// <summary> 
        /// 南北向
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50)]
        public string WareDirect { get; set; }

        /// <summary> 
        /// WareAreaId
        /// </summary> 
        [SugarColumn(ColumnDataType ="bigint" ,  IsNullable = false )]
        public long WareAreaId { get; set; }

        /// <summary> 
        /// 是否停止
        /// </summary> 
        [SugarColumn(ColumnDataType ="int" ,  IsNullable = false )]
        public int IsStop { get; set; }

        /// <summary> 
        /// 机台号
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = false )]
        public string MachNo { get; set; }

        /// <summary> 
        /// 名称
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 100  , IsNullable = false )]
        public string Name { get; set; }

        /// <summary> 
        /// 机台组
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = false )]
        public string GrpCode { get; set; }

        /// <summary> 
        /// AGV托盘位
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = false )]
        public string Station { get; set; }

        /// <summary> 
        /// 左/右手车
        /// </summary> 
        [SugarColumn(ColumnDataType ="nvarchar" , Length = 50  , IsNullable = false )]
        public string Direction { get; set; }
        /// <summary>
        /// 帘线工序工单号
        /// </summary>
        [SugarColumn(ColumnName = "DocCode", ColumnDataType = "nvarchar", Length = 50)]
        public string BillCode { get; set; }

        /// <summary>
        /// 生产订单号
        /// </summary>
        [SugarColumn(ColumnName = "WorkOrder", ColumnDataType = "nvarchar", Length = 50)]
        public string WorkOrder { get; set; }

        /// <summary>
        /// 垛型编码
        /// </summary>
        [SugarColumn(ColumnName = "SetGrpCode", ColumnDataType = "nvarchar", Length = 50)]
        public string SetGrpCode { get; set; }

        /// <summary>
        /// 预排帘线工序工单号
        /// </summary>
        [SugarColumn(ColumnName = "ProBillCode", ColumnDataType = "nvarchar", Length = 50)]
        public string ProBillCode { get; set; }

        /// <summary>
        /// 预排生产订单号
        /// </summary>
        [SugarColumn(ColumnName = "ProWorkOrder", ColumnDataType = "nvarchar", Length = 50)]
        public string ProWorkOrder { get; set; }

        /// <summary>
        /// 预排垛型编码
        /// </summary>
        [SugarColumn(ColumnName = "ProSetGrpCode", ColumnDataType = "nvarchar", Length = 50)]
        public string ProSetGrpCode { get; set; }

        /// <summary>
        /// 机器类型编码
        /// </summary>
        [SugarColumn(ColumnName = "MacTypeCode", ColumnDataType = "nvarchar", Length = 50)]
        public string MacTypeCode { get; set; }

        /// <summary>
        /// 机器类型名称
        /// </summary>
        [SugarColumn(ColumnName = "MacTypeName", ColumnDataType = "nvarchar", Length = 50)]
        public string MacTypeName { get; set; }
    }
}

