﻿using SqlSugar;
using System;
using System.Collections.Generic;
using System.Text;

namespace wms.sqlsugar.model.pt
{
    /// <summary>
    ///  甲方管理系统推送反馈
    /// </summary>
    [Tenant("pt")]
    [SugarTable(nameof(BillPushinfoHty) + "_{year}{month}{day}", "推送表")]
    [SplitTable(SplitType.Year)]//按年分表 （自带分表支持 年、季、月、周、日）
    public class BillPushinfoHty : BaseModel
    {
        /// <summary> 
        /// DocsNo
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string DocsNo { get; set; }

        /// <summary> 
        /// TypeCode
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = false)]
        public string TypeCode { get; set; }

        /// <summary> 
        /// RFIDBarCode
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string RFIDBarCode { get; set; }

        /// <summary> 
        /// RodBarCode
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string RodBarCode { get; set; }

        /// <summary> 
        /// HWBarCode
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string HWBarCode { get; set; }

        /// <summary> 
        /// CLBarCode
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string CLBarCode { get; set; }

        /// <summary> 
        /// WarehouseId
        /// </summary> 
        [SugarColumn(ColumnDataType = "bigint", IsNullable = true)]
        public long? WarehouseId { get; set; }

        /// <summary> 
        /// WarehouseCode
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string WarehouseCode { get; set; }

        /// <summary> 
        /// WareCellId
        /// </summary> 
        [SugarColumn(ColumnDataType = "bigint", IsNullable = true)]
        public long? WareCellId { get; set; }

        /// <summary> 
        /// WareCellCode
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string WareCellCode { get; set; }

        /// <summary> 
        /// BoilerNo
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string BoilerNo { get; set; }

        /// <summary> 
        /// PackNo
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string PackNo { get; set; }

        /// <summary> 
        /// BatchNo
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string BatchNo { get; set; }

        /// <summary> 
        /// ResStateCode
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string ResStateCode { get; set; }

        /// <summary> 
        /// ResDesc
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 500, IsNullable = true)]
        public string ResDesc { get; set; }

        /// <summary> 
        /// MatId
        /// </summary> 
        [SugarColumn(ColumnDataType = "bigint", IsNullable = true)]
        public long? MatId { get; set; }

        /// <summary> 
        /// MatCode
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string MatCode { get; set; }

        /// <summary> 
        /// MatName
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 100, IsNullable = true)]
        public string MatName { get; set; }

        /// <summary> 
        /// TolWQty
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false)]
        public decimal TolWQty { get; set; }

        /// <summary> 
        /// NetWQty
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false)]
        public decimal NetWQty { get; set; }

        /// <summary> 
        /// TareWQty
        /// </summary> 
        [SugarColumn(ColumnDataType = "decimal", Length = 18, IsNullable = false)]
        public decimal TareWQty { get; set; }

        /// <summary> 
        /// ReqNo
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string ReqNo { get; set; }

        /// <summary> 
        /// ReqGrpNo
        /// </summary> 
        [SugarColumn(ColumnDataType = "nvarchar", Length = 50, IsNullable = true)]
        public string ReqGrpNo { get; set; }

        /// <summary> 
        /// PostQty
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int PostQty { get; set; }

        /// <summary> 
        /// PostResult
        /// </summary> 
        [SugarColumn(ColumnDataType = "int", IsNullable = false)]
        public int PostResult { get; set; }
    }
}
